## dypgen-20120619-1.tar.bz2

=== Makefile ===
DIRS=calc calc_cpp calc_ext calc_nested_rule calc_ocamllex calc_pattern demo demo_ocamllex forest global_data local_data local_data_early_action merge_times_plus position position_ocamllex position_token_list sharp tinyML

include Makefile.config

dyp:
	cd dyplib; $(MAKE)
	cd dypgen; $(MAKE)

all:
	$(MAKE) dypgen
	$(MAKE) examples

examples:
	for i in $(DIRS); do \
		(cd demos/$$i; $(MAKE) all); \
	done

clean_examples:
	for i in $(DIRS) tinyML_ulex; do \
		(cd demos/$$i; $(MAKE) clean); \
	done

#install with ocaml-findlib
install: install_opt
	install -D --mode=755 dypgen/dypgen $(BINDIR)
	install -D --mode=755 dyp2gram.pl $(BINDIR)/dyp2gram
	install -D --mode=644 doc/dypgen.1 $(MANDIR)/dypgen.1
	install -D --mode=644 doc/dypgen.1 $(MANDIR)/dypgen.opt.1
	install -D --mode=644 doc/dypgen.1 $(MANDIR)/dyp2gram.1
	cd dyplib; $(MAKE) install

#install without ocaml-findlib
install2: install_opt
	install -D --mode=755 dypgen/dypgen $(BINDIR)
	install -D --mode=755 dyp2gram.pl $(BINDIR)/dyp2gram
	install -D --mode=644 doc/dypgen.1 $(MANDIR)/dypgen.1
	install -D --mode=644 doc/dypgen.1 $(MANDIR)/dypgen.opt.1
	install -D --mode=644 doc/dypgen.1 $(MANDIR)/dyp2gram.1
	cd dyplib; $(MAKE) install2

ifdef CAMLOPT
install_opt:
	mkdir -p $(BINDIR)
	cp dypgen/dypgen.opt $(BINDIR)
else
install_opt:
endif

uninstall:
	rm -rf $(BINDIR)/dypgen
	rm -rf $(BINDIR)/dypgen.opt
	rm -rf $(BINDIR)/dyp2gram.pl
	cd dyplib; $(MAKE) uninstall

uninstall2:
	rm -rf $(BINDIR)/dypgen
	rm -rf $(BINDIR)/dypgen.opt
	rm -rf $(BINDIR)/dyp2gram.pl
	cd $(DYPGENLIBDIR); rm -rf dyp.cmi dyp.cma dyp.cmxa dyp.a

clean:
	$(MAKE) clean_examples
	cd dyplib; $(MAKE) clean
	cd dypgen; $(MAKE) clean
	rm -f *~ dypgen-doc.log dypgen-doc.aux dypgen-doc.toc

=== dypgen/Makefile ===
include ../Makefile.config
SOURCES = argument.ml extract_type.mll dypgen_parser.ml dypgen_lexer.mll insert_linenum.mll dypgen.ml
REP = -I ../dyplib
CAMLC = ocamlc $(REP)
DYPGEN = ./dypgen --ocamlc "-rectypes -I ../dyplib"
LIBS=dyp.cma

all: dypgen dypgen.opt

SOURCES1 = $(SOURCES:.mll=.ml)
SOURCES2 = $(SOURCES1:.dyp=.ml)
OBJS = $(SOURCES2:.ml=.cmo)
OPTOBJS = $(SOURCES2:.ml=.cmx)

dypgen: parse_tree.cmi dypgen_parser.cmi $(OBJS)
	$(CAMLC) -o dypgen $(LIBS) $(OBJS)

ifdef CAMLOPT
dypgen.opt: parse_tree.cmi dypgen_parser.cmi $(OPTOBJS)
	$(CAMLOPT) $(REP) -o dypgen.opt $(LIBS:.cma=.cmxa) $(OPTOBJS)
else
dypgen.opt:
endif

.SUFFIXES: .ml .mli .cmo .cmi .cmx .mll

.ml.cmo:
	$(CAMLC) -c $<

.mli.cmi:
	$(CAMLC) -c $<

.ml.cmx:
	$(CAMLOPT) $(REP) -c $<

.mll.ml:
	ocamllex $<

clean:
	rm -f *.cm[iox] *~ .*~ *.o
	rm -f dypgen dypgen.opt sortie*
	rm -f *lexer.ml dypgen_parser.extract_type dypgen_parser_temp.ml

parser: parse_tree.cmi
	$(DYPGEN) dypgen_parser.dyp

clean_parser:
	rm -f dypgen_parser.ml dypgen_parser.mli

=== dyplib/Makefile ===
include ../Makefile.config

REP=
CAMLC=ocamlc
OCAMLFIND=ocamlfind

all: dyp opt prof

dyp: dyp.cmi priority_by_relation.cmo automaton.cmo dyplex.cmo dyp.cmo
	$(CAMLC) -a -o dyp.cma priority_by_relation.cmo automaton.cmo dyplex.cmo dyp.cmo

ifdef CAMLOPT
opt: dyp.cmi priority_by_relation.cmx automaton.cmx dyplex.cmx dyp.cmx
	$(CAMLOPT) -a -o dyp.cmxa priority_by_relation.cmx automaton.cmx dyplex.cmx dyp.cmx
prof: dyp.cmi priority_by_relation.p.cmx automaton.p.cmx dyplex.p.cmx dyp.p.cmx
	$(CAMLOPT) -a -o dyp.p.cmxa priority_by_relation.p.cmx automaton.p.cmx dyplex.p.cmx dyp.p.cmx
else
opt:
prof:
endif

install: uninstall
	install -d $(DYPGENLIBDIR)
	$(OCAMLFIND) install -destdir $(DYPGENLIBDIR) dyp META dyp.cma dyp.cmxa dyp.a dyp.cmi
	chmod a-x $(DYPGENLIBDIR)/dyp/META #why is this needed ?

uninstall:
	- $(OCAMLFIND) remove -destdir $(DYPGENLIBDIR) dyp

install2: install_dyp install_opt
	install -D --mode=644 dyp.cmi $(DYPGENLIBDIR)/dyp

install_dyp:
	install -D --mode=644 dyp.cma $(DYPGENLIBDIR)/dyp

ifdef CAMLOPT
install_opt:
	install -D --mode=644 dyp.cmxa $(DYPGENLIBDIR)/dyp
	install -D --mode=644 dyp.a $(DYPGENLIBDIR)/dyp
else
install_opt:
endif

ifdef CAMLOPT
.SUFFIXES: .ml .mli .cmo .cmi .cmx .p.cmx
else
.SUFFIXES: .ml .mli .cmo .cmi
endif

.ml.cmo:
	$(CAMLC) $(REP) -c $<

.mli.cmi:
	$(CAMLC) $(REP) -c $<

ifdef CAMLOPT
.ml.cmx:
	$(CAMLOPT) $(REP) -c $<
.ml.p.cmx:
	$(CAMLOPT) $(REP) -p -c -o $*.p.cmx $<
endif

clean:
	rm -f *.cm[iox] *~ .*~ *.o *.a *.cma *.cmxa

=== demos/calc_cpp/Makefile ===
all: calc

calc: calc_parser.dyp expr.dyp calc.ml
	../../dypgen/dypgen --cpp-options "-w" --ocamlc "-I ../../dyplib" calc_parser.dyp
	ocamlc -c -I ../../dyplib calc_parser.mli
	ocamlc -c -I ../../dyplib calc_parser.ml
	ocamlc -c -I ../../dyplib calc.ml
	ocamlc -o calc -I ../../dyplib dyp.cma calc_parser.cmo calc.cmo

clean:
	rm -f *.cm[iox] *~ .*~ *.o *parser.ml *parser.mli *.cpp.dyp *_temp.ml *.extract_type calc

=== demos/calc_ext/Makefile ===
SOURCES = calc_parser.dyp calc.ml
REP = -I ../../dyplib
CAMLC = ocamlc -rectypes $(REP)
DYPGEN = ../../dypgen/dypgen --ocamlc "-I ../../dyplib -rectypes"
LIBS=dyp.cma

all: calc

SOURCES2 = $(SOURCES:.dyp=.ml)
OBJS = $(SOURCES2:.ml=.cmo)

calc: $(OBJS)
	$(CAMLC) -o calc $(LIBS) $(OBJS)

.SUFFIXES: .ml .cmo .dyp

.ml.cmo:
	$(CAMLC) -c $<

.dyp.ml:
	$(DYPGEN) $<
	$(CAMLC) -c $*.mli

clean:
	rm -f *.cm[iox] *~ .*~ *.o
	rm -f calc
	rm -f *.extract_type *_temp.ml
	rm -f *parser.ml *parser.mli

=== demos/forest/Makefile ===
SOURCES = forest_parser.dyp forest.ml
REP = -I ../../dyplib
CAMLC = ocamlc $(REP)
DYPGEN = ../../dypgen/dypgen --ocamlc "-I ../../dyplib"
LIBS=dyp.cma

all: forest

SOURCES1 = $(SOURCES:.mll=.ml)
SOURCES2 = $(SOURCES1:.dyp=.ml)
OBJS = $(SOURCES2:.ml=.cmo)

forest: parse_tree.cmi $(OBJS)
	$(CAMLC) -o forest $(LIBS) $(OBJS)

.SUFFIXES: .ml .mli .cmo .cmi .dyp

.ml.cmo:
	$(CAMLC) -c $<

.mli.cmi:
	$(CAMLC) -c $<

.dyp.ml:
	$(DYPGEN) $<
	$(CAMLC) -c $*.mli

clean:
	rm -f *.cm[iox] *~ .*~ *.o
	rm -f forest
	rm -f *.extract_type *_temp.ml
	rm -f *parser.ml *parser.mli

=== demos/local_data/Makefile ===
SOURCES = parse_tree.ml local_data_parser.dyp local_data.ml
REP = -I ../../dyplib
CAMLC = ocamlc $(REP)
DYPGEN = ../../dypgen/dypgen --ocamlc "-I ../../dyplib"
LIBS=dyp.cma

all: local_data

SOURCES2 = $(SOURCES:.dyp=.ml)
OBJS = $(SOURCES2:.ml=.cmo)

local_data: $(OBJS)
	$(CAMLC) -o local_data $(LIBS) $(OBJS)

.SUFFIXES: .ml .cmo .dyp

.ml.cmo:
	$(CAMLC) -c $<

.dyp.ml:
	$(DYPGEN) $<
	$(CAMLC) -c $*.mli

clean:
	rm -f *.cm[iox] *~ .*~ *.o
	rm -f local_data
	rm -f *.extract_type *_temp.ml
	rm -f *parser.ml *parser.mli

=== demos/position/Makefile ===
SOURCES = parse_tree.ml position_parser.dyp position.ml
REP = -I ../../dyplib
CAMLC = ocamlc $(REP)
DYPGEN = ../../dypgen/dypgen --merge-warning --ocamlc "-I ../../dyplib"
LIBS=dyp.cma

all: position

SOURCES2 = $(SOURCES:.dyp=.ml)
OBJS = $(SOURCES2:.ml=.cmo)

position: $(OBJS)
	$(CAMLC) -o position $(LIBS) $(OBJS)

.SUFFIXES: .ml .mli .cmo .cmi .dyp

.ml.cmo:
	$(CAMLC) -c $<

.mli.cmi:
	$(CAMLC) -c $<

.dyp.ml:
	$(DYPGEN) $<
	$(CAMLC) -c $*.mli

clean:
	rm -f *.cm[iox] *~ .*~ *.o
	rm -f position
	rm -f *.extract_type *_temp.ml
	rm -f *parser.ml *parser.mli

=== debian/changelog ===
dypgen (0.20100625-1) unstable; urgency=low

  * Incorporate some bux fixes and reduces the patch needed

 -- Christophe Raffalli (LAMA - UMR 5127) <Christophe.Raffalli@univ-savoie.fr>  Fri, 24 Jun 2010 23:34:50 +0200

dypgen (0.20091118-1) unstable; urgency=low

  * Initial release (Closes: #586891)

 -- Christophe Raffalli (LAMA - UMR 5127) <Christophe.Raffalli@univ-savoie.fr>  Fri, 18 Jun 2010 17:34:50 +0200

=== debian/control ===
Source: dypgen
Section: devel
Priority: extra
Maintainer: Christophe Raffalli <christophe.raffalli@univ-savoie.fr>
Build-Depends: debhelper (>= 7), ocaml-base-nox | ocaml-base | ocaml-nox | ocaml, ocaml-findlib
Standards-Version: 3.8.3
Homepage: http://dypgen.free.fr/

Package: dypgen
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends},  ${ocaml:Depends}, libdypgen-ocaml-dev
Recommands: dypgen-doc
Description: A GLR parser and lexer generator for OCaml
 A GLR parser and lexer generator for OCaml with some unique features: 
 self extensible grammars, rejection of rule by exception, merge for 
 amiguous grammar, can output all parse-tree, handling or priorities 
 by arbitrary relation, automatically generated the lexer by using 
 strings as terminals, context dependent lexer, pattern matching in 
 rule, ...

Package: libdypgen-ocaml-dev
Section: ocaml
Architecture: any
Depends:
  ${ocaml:Depends},
  ${shlibs:Depends},
  ${misc:Depends}
Suggests: ocaml-findlib
Provides:
  ${ocaml:Provides}
Description: Dypgen library for OCaml
 This package contains the library containing the GLR engine for dypgen
 generated file.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

#!/usr/bin/make -f
# -*- makefile -*-

export DH_VERBOSE=1

include /usr/share/ocaml/ocamlvars.mk

%:
	dh --with quilt,ocaml $@
